--- emacs24-24.3+1.orig/lisp/progmodes/cc-langs.el
+++ emacs24-24.3+1/lisp/progmodes/cc-langs.el
@@ -1,32 +1,34 @@
 ;;; cc-langs.el --- language specific settings for CC Mode
 
-;; Copyright (C) 1985, 1987, 1992-2013 Free Software Foundation, Inc.
+;; Copyright (C) 1985, 1987, 1992, 1993, 1994, 1995, 1996, 1997, 1998,
+;;   1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009,
+;;   2010, 2011   Free Software Foundation, Inc.
 
 ;; Authors:    2002- Alan Mackenzie
-;;             1998- Martin Stjernholm
-;;             1992-1999 Barry A. Warsaw
-;;             1987 Dave Detlefs
-;;             1987 Stewart Clamen
-;;             1985 Richard M. Stallman
+;;	       1998- Martin Stjernholm
+;;	       1992-1999 Barry A. Warsaw
+;;	       1987 Dave Detlefs and Stewart Clamen
+;;	       1985 Richard M. Stallman
 ;; Maintainer: bug-cc-mode@gnu.org
 ;; Created:    22-Apr-1997 (split from cc-mode.el)
-;; Keywords:   c languages
-;; Package:    cc-mode
+;; Version:    See cc-mode.el
+;; Keywords:   c languages oop
 
 ;; This file is part of GNU Emacs.
 
-;; GNU Emacs is free software: you can redistribute it and/or modify
+;; GNU Emacs is free software; you can redistribute it and/or modify
 ;; it under the terms of the GNU General Public License as published by
-;; the Free Software Foundation, either version 3 of the License, or
-;; (at your option) any later version.
+;; the Free Software Foundation; either version 3, or (at your option)
+;; any later version.
 
 ;; GNU Emacs is distributed in the hope that it will be useful,
 ;; but WITHOUT ANY WARRANTY; without even the implied warranty of
-;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 ;; GNU General Public License for more details.
 
 ;; You should have received a copy of the GNU General Public License
-;; along with GNU Emacs.  If not, see <http://www.gnu.org/licenses/>.
+;; along with this program; see the file COPYING.  If not, see
+;; <http://www.gnu.org/licenses/>.
 
 ;;; Commentary:
 
@@ -47,7 +49,7 @@
 ;;; Introduction to the language dependent variable system:
 ;;
 ;; This file contains all the language dependent variables, except
-;; those specific for font locking which reside in cc-fonts.el.  As
+;; those specific for font locking which reside in cc-fonts.el.	 As
 ;; far as possible, all the differences between the languages that CC
 ;; Mode supports are described with these variables only, so that the
 ;; code can be shared.
@@ -85,21 +87,21 @@
 ;; evaluation; the byte compiled file(s) for them will contain the
 ;; compiled runtime constants ready for use by (the byte compiled) CC
 ;; Mode, and the source definitions in this file don't have to be
-;; loaded then.  However, if a byte compiled package is loaded that
+;; loaded then.	 However, if a byte compiled package is loaded that
 ;; has been compiled with a different version of CC Mode than the one
 ;; currently loaded, then the compiled-in values will be discarded and
-;; new ones will be built when the mode is initialized.  That will
+;; new ones will be built when the mode is initialized.	 That will
 ;; automatically trig a load of the file(s) containing the source
 ;; definitions (i.e. this file and/or cc-fonts.el) if necessary.
 ;;
 ;; A small example of a derived mode is available at
-;; <http://cc-mode.sourceforge.net/derived-mode-ex.el>.  It also
+;; <http://cc-mode.sourceforge.net/derived-mode-ex.el>.	 It also
 ;; contains some useful hints for derived mode developers.
 
 ;;; Using language variables:
 ;;
 ;; The `c-lang-defvar' forms in this file comprise the language
-;; variables that CC Mode uses.  It does not work to use
+;; variables that CC Mode uses.	 It does not work to use
 ;; `c-lang-defvar' anywhere else (which isn't much of a limitation
 ;; since these variables sole purpose is to interface with the CC Mode
 ;; core functions).  The values in these `c-lang-defvar's are not
@@ -113,10 +115,6 @@
 
 ;;; Code:
 
-;; For Emacs < 22.2.
-(eval-and-compile
-  (unless (fboundp 'declare-function) (defmacro declare-function (&rest r))))
-
 (eval-when-compile
   (let ((load-path
 	 (if (and (boundp 'byte-compile-dest-file)
@@ -151,8 +149,8 @@
 	c-emacs-variable-inits-tail c-emacs-variable-inits))
 
 (defmacro c-lang-defvar (var val &optional doc)
-  "Declares the buffer local variable VAR to get the value VAL.  VAL is
-evaluated and assigned at mode initialization.  More precisely, VAL is
+  "Declares the buffer local variable VAR to get the value VAL.	 VAL is
+evaluated and assigned at mode initialization.	More precisely, VAL is
 evaluated and bound to VAR when the result from the macro
 `c-init-language-vars' is evaluated.
 
@@ -201,17 +199,9 @@ the evaluated constant value at compile
   `',var)
 
 (put 'c-lang-defvar 'lisp-indent-function 'defun)
-; (eval-after-load "edebug" ; 2006-07-09: def-edebug-spec is now in subr.el.
-;  '
-(def-edebug-spec c-lang-defvar
-  (&define name def-form &optional stringp)) ;)
-
-;; Suppress "might not be defined at runtime" warning.
-;; This file is only used when compiling other cc files.
-;; These are defined in cl as aliases to the cl- versions.
-(declare-function delete-duplicates "cl-seq" (cl-seq &rest cl-keys) t)
-(declare-function mapcan "cl-extra" (cl-func cl-seq &rest cl-rest) t)
-(declare-function cl-macroexpand-all "cl" (form &optional env))
+(eval-after-load "edebug"
+  '(def-edebug-spec c-lang-defvar
+     (&define name def-form &optional stringp)))
 
 (eval-and-compile
   ;; Some helper functions used when building the language constants.
@@ -271,29 +261,29 @@ the evaluated constant value at compile
 ;;; Various mode specific values that aren't language related.
 
 (c-lang-defconst c-mode-menu
-  ;; The definition for the mode menu.  The menu title is prepended to
+  ;; The definition for the mode menu.	The menu title is prepended to
   ;; this before it's fed to `easy-menu-define'.
-  t `(["Comment Out Region"     comment-region
+  t `(["Comment Out Region"	comment-region
        (c-fn-region-is-active-p)]
-      ["Uncomment Region"       (comment-region (region-beginning)
+      ["Uncomment Region"	(comment-region (region-beginning)
 						(region-end) '(4))
        (c-fn-region-is-active-p)]
-      ["Indent Expression"      c-indent-exp
+      ["Indent Expression"	c-indent-exp
        (memq (char-after) '(?\( ?\[ ?\{))]
-      ["Indent Line or Region"  c-indent-line-or-region t]
+      ["Indent Line or Region"	c-indent-line-or-region t]
       ["Fill Comment Paragraph" c-fill-paragraph t]
       "----"
-      ["Backward Statement"     c-beginning-of-statement t]
-      ["Forward Statement"      c-end-of-statement t]
+      ["Backward Statement"	c-beginning-of-statement t]
+      ["Forward Statement"	c-end-of-statement t]
       ,@(when (c-lang-const c-opt-cpp-prefix)
 	  ;; Only applicable if there's a cpp preprocessor.
-	  `(["Up Conditional"         c-up-conditional t]
+	  `(["Up Conditional"	      c-up-conditional t]
 	    ["Backward Conditional"   c-backward-conditional t]
 	    ["Forward Conditional"    c-forward-conditional t]
 	    "----"
 	    ["Macro Expand Region"    c-macro-expand
 	     (c-fn-region-is-active-p)]
-	    ["Backslashify"           c-backslash-region
+	    ["Backslashify"	      c-backslash-region
 	     (c-fn-region-is-active-p)]))
       "----"
       ("Style..."
@@ -302,7 +292,7 @@ the evaluated constant value at compile
 					  "Style Name: %s"
 					  c-indentation-style) t]
        ["Guess Style from this Buffer"   c-guess-buffer-no-install t]
-       ["Install the Last Guessed Style..." c-guess-install
+       ["Install the Last Guessed Style" c-guess-install
 	(and c-guess-guessed-offsets-alist
 	     c-guess-guessed-basic-offset) ]
        ["View the Last Guessed Style"    c-guess-view
@@ -310,17 +300,11 @@ the evaluated constant value at compile
 	     c-guess-guessed-basic-offset) ])
       "----"
       ("Toggle..."
-       ["Syntactic indentation" c-toggle-syntactic-indentation
-	:style toggle :selected c-syntactic-indentation]
-       ["Electric mode"         c-toggle-electric-state
-	:style toggle :selected c-electric-flag]
-       ["Auto newline"          c-toggle-auto-newline
-	:style toggle :selected c-auto-newline]
-       ["Hungry delete"         c-toggle-hungry-state
-	:style toggle :selected c-hungry-delete-key]
-       ["Subword mode"          subword-mode
-	:style toggle :selected (and (boundp 'subword-mode)
-                                     subword-mode)])))
+       ["Syntactic indentation" c-toggle-syntactic-indentation t]
+       ["Electric mode"		c-toggle-electric-state t]
+       ["Auto newline"		c-toggle-auto-newline t]
+       ["Hungry delete"		c-toggle-hungry-state t]
+       ["Subword mode"		c-subword-mode t])))
 
 
 ;;; Syntax tables.
@@ -331,17 +315,17 @@ This includes setting ' and \" as string
 the comment syntax to handle both line style \"//\" and block style
 \"/*\" \"*/\" comments."
 
-  (modify-syntax-entry ?_  "_"     table)
-  (modify-syntax-entry ?\\ "\\"    table)
-  (modify-syntax-entry ?+  "."     table)
-  (modify-syntax-entry ?-  "."     table)
-  (modify-syntax-entry ?=  "."     table)
-  (modify-syntax-entry ?%  "."     table)
-  (modify-syntax-entry ?<  "."     table)
-  (modify-syntax-entry ?>  "."     table)
-  (modify-syntax-entry ?&  "."     table)
-  (modify-syntax-entry ?|  "."     table)
-  (modify-syntax-entry ?\' "\""    table)
+  (modify-syntax-entry ?_  "_"	   table)
+  (modify-syntax-entry ?\\ "\\"	   table)
+  (modify-syntax-entry ?+  "."	   table)
+  (modify-syntax-entry ?-  "."	   table)
+  (modify-syntax-entry ?=  "."	   table)
+  (modify-syntax-entry ?%  "."	   table)
+  (modify-syntax-entry ?<  "."	   table)
+  (modify-syntax-entry ?>  "."	   table)
+  (modify-syntax-entry ?&  "."	   table)
+  (modify-syntax-entry ?|  "."	   table)
+  (modify-syntax-entry ?\' "\""	   table)
   (modify-syntax-entry ?\240 "."   table)
 
   ;; Set up block and line oriented comments.  The new C
@@ -389,10 +373,12 @@ The syntax tables aren't stored directly
 (c-lang-defconst c++-make-template-syntax-table
   ;; A variant of `c++-mode-syntax-table' that defines `<' and `>' as
   ;; parenthesis characters.  Used temporarily when template argument
-  ;; lists are parsed.  Note that this encourages incorrect parsing of
+  ;; lists are parsed.	Note that this encourages incorrect parsing of
   ;; templates since they might contain normal operators that uses the
   ;; '<' and '>' characters.  Therefore this syntax table might go
-  ;; away when CC Mode handles templates correctly everywhere.
+  ;; away when CC Mode handles templates correctly everywhere.  WHILE
+  ;; THIS SYNTAX TABLE IS CURRENT, `c-parse-state' MUST _NOT_ BE
+  ;; CALLED!!!
   t   nil
   (java c++) `(lambda ()
 	 (let ((table (funcall ,(c-lang-const c-make-mode-syntax-table))))
@@ -434,7 +420,7 @@ element is a cons where the car is the c
 the new syntax, as accepted by `modify-syntax-entry'."
   ;; The $ character is not allowed in most languages (one exception
   ;; is Java which allows it for legacy reasons) but we still classify
-  ;; it as an identifier character since it's often used in various
+  ;; it as an indentifier character since it's often used in various
   ;; machine generated identifiers.
   t    '((?_ . "w") (?$ . "w"))
   (objc java) (append '((?@ . "w"))
@@ -477,7 +463,7 @@ Typically these will record enough state
 and may do such things as removing text-properties which must be
 recalculated.
 
-These functions will be run in the order given.  Each of them
+These functions will be run in the order given.	 Each of them
 takes 2 parameters, the BEG and END supplied to every
 before-change function; on entry, the buffer will have been
 widened and match-data will have been saved; point is undefined
@@ -553,7 +539,7 @@ don't have EOL terminated statements. "
 
 (c-lang-defconst c-vsemi-status-unknown-p-fn
   "Contains a function \"are we unsure whether there is a virtual semicolon on this line?\".
-The (admittedly kludgy) purpose of such a function is to prevent an infinite
+The (admittedly kludgey) purpose of such a function is to prevent an infinite
 recursion in c-beginning-of-statement-1 when point starts at a `while' token.
 The function MUST NOT UNDER ANY CIRCUMSTANCES call c-beginning-of-statement-1,
 even indirectly.  This variable contains nil for languages which don't have
@@ -573,13 +559,22 @@ EOL terminated statements."
   (c c++ objc) t)
 (c-lang-defvar c-has-bitfields (c-lang-const c-has-bitfields))
 
+(c-lang-defconst c-modified-constant
+  "Regexp that matches a \"modified\" constant literal such as \"L'a'\",
+a \"long character\".  In particular, this recognizes forms of constant
+which c-backward-sexp needs to be called twice to move backwards over."
+  t nil
+  (c c++ objc) "L'\\([^\\'\t\f\n\r]\\|\\\\.\\)'")
+;; FIXME!!!  Extend this to cover strings, if needed.  2008-04-11
+(c-lang-defvar c-modified-constant (c-lang-const c-modified-constant))
+
 (c-lang-defconst c-symbol-start
   "Regexp that matches the start of a symbol, i.e. any identifier or
 keyword.  It's unspecified how far it matches.	Does not contain a \\|
 operator at the top level."
   t    (concat "[" c-alpha "_]")
   java (concat "[" c-alpha "_@]")
-  objc (concat "[" c-alpha "_@]")
+  objc (concat "[" c-alpha "@]")
   pike (concat "[" c-alpha "_`]"))
 (c-lang-defvar c-symbol-start (c-lang-const c-symbol-start))
 
@@ -593,7 +588,7 @@ This is of the form that fits inside [ ]
 (c-lang-defvar c-symbol-chars (c-lang-const c-symbol-chars))
 
 (c-lang-defconst c-symbol-key
-  "Regexp matching identifiers and keywords (with submatch 0).  Assumed
+  "Regexp matching identifiers and keywords (with submatch 0).	Assumed
 to match if `c-symbol-start' matches on the same position."
   t    (concat (c-lang-const c-symbol-start)
 	       "[" (c-lang-const c-symbol-chars) "]*")
@@ -626,7 +621,7 @@ It's assumed to not contain any submatch
 
 (c-lang-defconst c-identifier-ops
   "The operators that make up fully qualified identifiers.  nil in
-languages that don't have such things.  See `c-operators' for a
+languages that don't have such things.	See `c-operators' for a
 description of the format.  Binary operators can concatenate symbols,
 e.g. \"::\" in \"A::B::C\".  Prefix operators can precede identifiers,
 e.g. \"~\" in \"~A::B\".  Other types of operators aren't supported.
@@ -681,7 +676,7 @@ This value is by default merged into `c-
 
 (c-lang-defconst c-after-id-concat-ops
   "Operators that can occur after a binary operator on `c-identifier-ops'
-in identifiers.  nil in languages that don't have such things.
+in identifiers.	 nil in languages that don't have such things.
 
 Operators here should also have appropriate entries in `c-operators' -
 it's not taken care of by default."
@@ -803,7 +798,7 @@ literal are multiline."
   "Regexp matching the prefix of a cpp directive in the languages that
 normally use that macro preprocessor.  Tested at bol or at boi.
 Assumed to not contain any submatches or \\| operators."
-  ;; TODO (ACM, 2005-04-01).  Amend the following to recognize escaped NLs;
+  ;; TODO (ACM, 2005-04-01).  Amend the following to recognise escaped NLs;
   ;; amend all uses of c-opt-cpp-prefix which count regexp-depth.
   t "\\s *#\\s *"
   (java awk) nil)
@@ -812,13 +807,13 @@ Assumed to not contain any submatches or
 (c-lang-defconst c-anchored-cpp-prefix
   "Regexp matching the prefix of a cpp directive anchored to BOL,
 in the languages that have a macro preprocessor."
-  t (if (c-lang-const c-opt-cpp-prefix)
-	(concat "^" (c-lang-const c-opt-cpp-prefix))))
+  t "^\\s *\\(#\\)\\s *"
+  (java awk) nil)
 (c-lang-defvar c-anchored-cpp-prefix (c-lang-const c-anchored-cpp-prefix))
 
 (c-lang-defconst c-opt-cpp-start
   "Regexp matching the prefix of a cpp directive including the directive
-name, or nil in languages without preprocessor support.  The first
+name, or nil in languages without preprocessor support.	 The first
 submatch surrounds the directive name."
   t    (if (c-lang-const c-opt-cpp-prefix)
 	   (concat (c-lang-const c-opt-cpp-prefix)
@@ -852,13 +847,13 @@ definition, or nil if the language doesn
 
 (c-lang-defconst c-opt-cpp-macro-define-start
   ;; Regexp matching everything up to the macro body of a cpp define, or the
-  ;; end of the logical line if there is none.  Submatch 1 is the name of the
+  ;; end of the logical line if there is none.	Submatch 1 is the name of the
   ;; macro.  Set if c-opt-cpp-macro-define is.
   t (if (c-lang-const c-opt-cpp-macro-define)
 	(concat (c-lang-const c-opt-cpp-prefix)
 		(c-lang-const c-opt-cpp-macro-define)
 		"[ \t]+\\(\\(\\sw\\|_\\)+\\)\\(\([^\)]*\)\\)?"
-		;;       ^                 ^ #defined name
+		;;	 ^		   ^ #defined name
 		"\\([ \t]\\|\\\\\n\\)*")))
 (c-lang-defvar c-opt-cpp-macro-define-start
   (c-lang-const c-opt-cpp-macro-define-start))
@@ -906,26 +901,26 @@ expression, or nil if there aren't any i
 
 (c-lang-defconst c-operators
   "List describing all operators, along with their precedence and
-associativity.  The order in the list corresponds to the precedence of
+associativity.	The order in the list corresponds to the precedence of
 the operators: The operators in each element are a group with the same
 precedence, and the group has higher precedence than the groups in all
 following elements.  The car of each element describes the type of the
 operator group, and the cdr is a list of the operator tokens in it.
 The operator group types are:
 
-'prefix         Unary prefix operators.
-'postfix        Unary postfix operators.
+'prefix		Unary prefix operators.
+'postfix	Unary postfix operators.
 'postfix-if-paren
 		Unary postfix operators if and only if the chars have
 		parenthesis syntax.
-'left-assoc     Binary left associative operators (i.e. a+b+c means (a+b)+c).
-'right-assoc    Binary right associative operators (i.e. a=b=c means a=(b=c)).
+'left-assoc	Binary left associative operators (i.e. a+b+c means (a+b)+c).
+'right-assoc	Binary right associative operators (i.e. a=b=c means a=(b=c)).
 'right-assoc-sequence
-                Right associative operator that constitutes of a
-                sequence of tokens that separate expressions.  All the
-                tokens in the group are in this case taken as
-                describing the sequence in one such operator, and the
-                order between them is therefore significant.
+		Right associative operator that constitutes of a
+		sequence of tokens that separate expressions.  All the
+		tokens in the group are in this case taken as
+		describing the sequence in one such operator, and the
+		order between them is therefore significant.
 
 Operators containing a character with paren syntax are taken to match
 with a corresponding open/close paren somewhere else.  A postfix
@@ -1060,7 +1055,7 @@ since CC Mode treats every identifier as
 	;; Primary.
 	,@(c-lang-const c-identifier-ops)
 	;; Unary.
-	(prefix  "+" "-" "~")
+	(prefix	 "+" "-" "~")
 	;; Multiplicative.
 	(left-assoc "*" "/" "%")
 	;; Additive.
@@ -1080,7 +1075,7 @@ since CC Mode treats every identifier as
 
 (c-lang-defconst c-overloadable-operators
   "List of the operators that are overloadable, in their \"identifier
-form\".  See also `c-op-identifier-prefix'."
+form\".	 See also `c-op-identifier-prefix'."
   t    nil
   c++  '("new" "delete" ;; Can be followed by "[]" but we ignore that.
 	 "+" "-" "*" "/" "%"
@@ -1120,7 +1115,7 @@ This regexp is assumed to not match any
 ;; Note: the following alias is an old name which was a mis-spelling.  It has
 ;; been corrected above and throughout cc-engine.el.  It will be removed at
 ;; some release very shortly in the future.  ACM, 2006-04-14.
-(defvaralias 'c-opt-op-identitier-prefix 'c-opt-op-identifier-prefix)
+(defalias 'c-opt-op-identitier-prefix 'c-opt-op-identifier-prefix)
 (make-obsolete-variable 'c-opt-op-identitier-prefix 'c-opt-op-identifier-prefix
 			"CC Mode 5.31.4, 2006-04-14")
 
@@ -1233,7 +1228,7 @@ operators."
 (c-lang-defconst c-stmt-delim-chars
   ;; The characters that should be considered to bound statements.  To
   ;; optimize `c-crosses-statement-barrier-p' somewhat, it's assumed to
-  ;; begin with "^" to negate the set.  If ? : operators should be
+  ;; begin with "^" to negate the set.	If ? : operators should be
   ;; detected then the string must end with "?:".
   t "^;{}?:")
 (c-lang-defvar c-stmt-delim-chars (c-lang-const c-stmt-delim-chars))
@@ -1263,7 +1258,7 @@ Line comments are always terminated by n
 `c-block-comment-starter' and this one is assumed to be set.
 
 Note that it's currently not enough to set this to support a new
-comment style.  Other stuff like the syntax table must also be set up
+comment style.	Other stuff like the syntax table must also be set up
 properly."
   t    "//"
   awk  "#")
@@ -1276,7 +1271,7 @@ to be set if this is.  At least one of `
 this one is assumed to be set.
 
 Note that it's currently not enough to set this to support a new
-comment style.  Other stuff like the syntax table must also be set up
+comment style.	Other stuff like the syntax table must also be set up
 properly."
   t    "/*"
   awk  nil)
@@ -1285,7 +1280,7 @@ properly."
   "String that ends block comments, or nil if such don't exist.
 
 Note that it's currently not enough to set this to support a new
-comment style.  Other stuff like the syntax table must also be set up
+comment style.	Other stuff like the syntax table must also be set up
 properly."
   t    "*/"
   awk  nil)
@@ -1447,7 +1442,7 @@ properly."
   ;; allow line breaks is to avoid going very far and risk running out
   ;; of regexp stack; this regexp is intended to handle only short
   ;; comments that might be put in the middle of limited constructs
-  ;; like declarations.  Does not contain a \| operator at the top
+  ;; like declarations.	 Does not contain a \| operator at the top
   ;; level.
   t (when (c-lang-const c-unterminated-block-comment-regexp)
       (concat
@@ -1464,7 +1459,7 @@ properly."
 
 (c-lang-defconst c-nonwhite-syntactic-ws
   ;; Regexp matching a piece of syntactic whitespace that isn't a
-  ;; sequence of simple whitespace characters.  As opposed to
+  ;; sequence of simple whitespace characters.	As opposed to
   ;; `c-(forward|backward)-syntactic-ws', this doesn't regard cpp
   ;; directives as syntactic whitespace.
   t (c-concat-separated
@@ -1545,13 +1540,14 @@ properly."
 (c-lang-defvar c-syntactic-eol (c-lang-const c-syntactic-eol))
 
 
-;;; Defun functions
+;;; Defun handling.
 
-;; The Emacs variables beginning-of-defun-function and
-;; end-of-defun-function will be set so that commands like
-;; `mark-defun' and `narrow-to-defun' work right.  The key sequences
-;; C-M-a and C-M-e are, however, bound directly to the CC Mode
-;; functions, allowing optimization for large n.
+;; The Emacs variables beginning-of-defun-function and end-of-defun-function
+;; will be set so that commands like `mark-defun' and `narrow-to-defun' work
+;; right.  In older Emacsen, the key sequences C-M-a and C-M-e are, however,
+;; bound directly to the CC Mode functions, allowing optimisation for large n.
+;; From Emacs 23, this isn't necessary any more, since n is passed to the two
+;; functions.
 (c-lang-defconst beginning-of-defun-function
   "Function to which beginning-of-defun-function will be set."
   t 'c-beginning-of-defun
@@ -1564,6 +1560,7 @@ properly."
   t 'c-end-of-defun
   awk 'c-awk-end-of-defun)
 (c-lang-setvar end-of-defun-function (c-lang-const end-of-defun-function))
+
 
 ;;; In-comment text handling.
 
@@ -1634,9 +1631,9 @@ the appropriate place for that."
 (c-lang-defconst c-primitive-type-prefix-kwds
   "Keywords that might act as prefixes for primitive types.  Assumed to
 be a subset of `c-primitive-type-kwds'."
-  t       nil
+  t	  nil
   (c c++) '("long" "short" "signed" "unsigned")
-  idl     '("long" "unsigned"
+  idl	  '("long" "unsigned"
 	    ;; In CORBA PSDL:
 	    "strong"))
 
@@ -1847,7 +1844,7 @@ will be handled."
 
 (c-lang-defconst c-modifier-kwds
   "Keywords that can prefix normal declarations of identifiers
-\(and typically act as flags).  Things like argument declarations
+\(and typically act as flags).	Things like argument declarations
 inside function headers are also considered declarations in this
 sense.
 
@@ -1884,10 +1881,10 @@ If any of these also are on `c-type-list
 `c-colon-type-list-kwds', `c-paren-nontype-kwds', `c-paren-type-kwds',
 `c-<>-type-kwds', or `c-<>-arglist-kwds' then the associated clauses
 will be handled."
-  t       nil
-  objc    '("@class" "@end" "@defs")
-  java    '("import" "package")
-  pike    '("import" "inherit"))
+  t	  nil
+  objc	  '("@class" "@end" "@defs")
+  java	  '("import" "package")
+  pike	  '("import" "inherit"))
 
 (c-lang-defconst c-decl-start-kwds
   "Keywords that always start declarations, wherever they occur.
@@ -2017,9 +2014,9 @@ like that, it ends with the following ';
 
 The keywords on list are assumed to also be present on one of the
 `*-decl-kwds' lists."
-  t        nil
+  t	   nil
   (c objc) '("struct" "union" "enum" "typedef")
-  c++      '("class" "struct" "union" "enum" "typedef"))
+  c++	   '("class" "struct" "union" "enum" "typedef"))
 
 (c-lang-defconst c-opt-block-decls-with-vars-key
   ;; Regexp matching the `c-block-decls-with-vars' keywords, or nil in
@@ -2040,6 +2037,12 @@ declarations."
 	 ;; In CORBA PSDL:
 	 "as" "const" "implements" "of" "ref"))
 
+(c-lang-defconst c-postfix-decl-spec-key
+  ;; Regexp matching the keywords in `c-postfix-decl-spec-kwds'.
+  t (c-make-keywords-re t (c-lang-const c-postfix-decl-spec-kwds)))
+(c-lang-defvar c-postfix-decl-spec-key
+  (c-lang-const c-postfix-decl-spec-key))
+
 (c-lang-defconst c-nonsymbol-sexp-kwds
   "Keywords that may be followed by a nonsymbol sexp before whatever
 construct it's part of continues."
@@ -2048,7 +2051,7 @@ construct it's part of continues."
 
 (c-lang-defconst c-type-list-kwds
   "Keywords that may be followed by a comma separated list of type
-identifiers, where each optionally can be prefixed by keywords.  (Can
+identifiers, where each optionally can be prefixed by keywords.	 (Can
 also be used for the special case when the list can contain only one
 element.)
 
@@ -2073,7 +2076,7 @@ or variable identifier (that's being def
 (c-lang-defconst c-ref-list-kwds
   "Keywords that may be followed by a comma separated list of
 reference (i.e. namespace/scope/module) identifiers, where each
-optionally can be prefixed by keywords.  (Can also be used for the
+optionally can be prefixed by keywords.	 (Can also be used for the
 special case when the list can contain only one element.)  Assumed to
 be mutually exclusive with `c-type-list-kwds'.
 
@@ -2090,7 +2093,7 @@ or variable identifier (that's being def
 (c-lang-defconst c-colon-type-list-kwds
   "Keywords that may be followed (not necessarily directly) by a colon
 and then a comma separated list of type identifiers, where each
-optionally can be prefixed by keywords.  (Can also be used for the
+optionally can be prefixed by keywords.	 (Can also be used for the
 special case when the list can contain only one element.)"
   t    nil
   c++  '("class" "struct")
@@ -2106,7 +2109,7 @@ regexp if `c-colon-type-list-kwds' isn't
   t (if (c-lang-const c-colon-type-list-kwds)
 	;; Disallow various common punctuation chars that can't come
 	;; before the ":" that starts the inherit list after "class"
-	;; or "struct" in C++.  (Also used as default for other
+	;; or "struct" in C++.	(Also used as default for other
 	;; languages.)
 	"[^\]\[{}();,/#=:]*:"))
 (c-lang-defvar c-colon-type-list-re (c-lang-const c-colon-type-list-re))
@@ -2114,7 +2117,7 @@ regexp if `c-colon-type-list-kwds' isn't
 (c-lang-defconst c-paren-nontype-kwds
   "Keywords that may be followed by a parenthesis expression that doesn't
 contain type identifiers."
-  t       nil
+  t	  nil
   (c c++) '(;; GCC extension.
 	    "__attribute__"
 	    ;; MSVC extension.
@@ -2136,9 +2139,9 @@ type identifiers separated by arbitrary
 
 (c-lang-defconst c-<>-type-kwds
   "Keywords that may be followed by an angle bracket expression
-containing type identifiers separated by \",\".  The difference from
+containing type identifiers separated by \",\".	 The difference from
 `c-<>-arglist-kwds' is that unknown names are taken to be types and
-not other identifiers.  `c-recognize-<>-arglists' is assumed to be set
+not other identifiers.	`c-recognize-<>-arglists' is assumed to be set
 if this isn't nil."
   t    nil
   objc '("id")
@@ -2148,7 +2151,7 @@ if this isn't nil."
 
 (c-lang-defconst c-<>-arglist-kwds
   "Keywords that can be followed by a C++ style template arglist; see
-`c-recognize-<>-arglists' for details.  That language constant is
+`c-recognize-<>-arglists' for details.	That language constant is
 assumed to be set if this isn't nil."
   t    nil
   c++  '("template")
@@ -2163,8 +2166,7 @@ assumed to be set if this isn't nil."
 (c-lang-defconst c-opt-<>-sexp-key
   ;; Adorned regexp matching keywords that can be followed by an angle
   ;; bracket sexp.  Always set when `c-recognize-<>-arglists' is.
-  t (if (c-lang-const c-recognize-<>-arglists)
-	(c-make-keywords-re t (c-lang-const c-<>-sexp-kwds))))
+  t (c-make-keywords-re t (c-lang-const c-<>-sexp-kwds)))
 (c-lang-defvar c-opt-<>-sexp-key (c-lang-const c-opt-<>-sexp-key))
 
 (c-lang-defconst c-brace-id-list-kwds
@@ -2177,7 +2179,6 @@ identifiers that follows the type in a n
   "Statement keywords followed directly by a substatement."
   t    '("do" "else")
   c++  '("do" "else" "try")
-  objc '("do" "else" "@finally" "@try")
   java '("do" "else" "finally" "try")
   idl  nil)
 
@@ -2187,11 +2188,22 @@ identifiers that follows the type in a n
   t (c-make-keywords-re t (c-lang-const c-block-stmt-1-kwds)))
 (c-lang-defvar c-block-stmt-1-key (c-lang-const c-block-stmt-1-key))
 
+(c-lang-defconst c-block-stmt-1-2-kwds
+  "Statement keywords optionally followed by a paren sexp.
+Keywords here should also be in `c-block-stmt-1-kwds'."
+  t nil
+  java '("try"))
+
+(c-lang-defconst c-block-stmt-1-2-key
+  ;; Regexp matching the start of a statement which may be followed by a
+  ;; paren sexp and will then be followed by a substatement.
+  t (c-make-keywords-re t (c-lang-const c-block-stmt-1-2-kwds)))
+(c-lang-defvar c-block-stmt-1-2-key (c-lang-const c-block-stmt-1-2-key))
+
 (c-lang-defconst c-block-stmt-2-kwds
   "Statement keywords followed by a paren sexp and then by a substatement."
   t    '("for" "if" "switch" "while")
   c++  '("for" "if" "switch" "while" "catch")
-  objc '("for" "if" "switch" "while" "@catch" "@synchronized")
   java '("for" "if" "switch" "while" "catch" "synchronized")
   idl  nil
   pike '("for" "if" "switch" "while" "foreach")
@@ -2223,7 +2235,6 @@ identifiers that follows the type in a n
 (c-lang-defconst c-simple-stmt-kwds
   "Statement keywords followed by an expression or nothing."
   t    '("break" "continue" "goto" "return")
-  objc '("break" "continue" "goto" "return" "@throw")
   ;; Note: `goto' is not valid in Java, but the keyword is still reserved.
   java '("break" "continue" "goto" "return" "throw")
   idl  nil
